using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;

namespace SyncDBGGrid
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private SyncDBGGrid.Dataset1 dataset11;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.dataset11 = new SyncDBGGrid.Dataset1();
			this.button2 = new System.Windows.Forms.Button();
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.dataset11)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(32, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(104, 23);
			this.button1.TabIndex = 0;
			this.button1.Text = "Load Data";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// dataset11
			// 
			this.dataset11.DataSetName = "Dataset1";
			this.dataset11.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(176, 24);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(104, 23);
			this.button2.TabIndex = 2;
			this.button2.Text = "Add Columns";
			this.button2.Click += new System.EventHandler(this.button2_Click_1);
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.DataMember = "";
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 80);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(824, 488);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 3;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.PrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventHandler(this.gridDataBoundGrid1_PrepareViewStyleInfo);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(880, 600);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dataset11)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private GridHierarchyLevel m_Quotes = null;
		private GridHierarchyLevel m_Root = null;

		private void FillDataSEt()
		{
			// Fill DataSet
			for(Int32 i = 0; i < 300; i++)
			{
				Dataset1.PortfolioRow p = dataset11.Portfolio.NewPortfolioRow() ;
				p.ID = Guid.NewGuid().ToString();
				p.Portfolio = "Portfolio number " + i.ToString();

				dataset11.Portfolio.AddPortfolioRow(p);

				for(Int32 j = 0; j < 7; j++) 
				{
					dataset11.Quote.AddQuoteRow(Guid.NewGuid().ToString(), p, "Symbol " + j.ToString(), "1 Minute", DateTime.Now,
						j, j, j, j, j);
				}
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.Cursor = Cursors.WaitCursor;
			this.gridDataBoundGrid1.BeginUpdate(Syncfusion.Windows.Forms.BeginUpdateOptions.Invalidate);

			gridDataBoundGrid1.DataSource = dataset11;
			gridDataBoundGrid1.DataMember = dataset11.Portfolio.TableName;

			 m_Quotes =  gridDataBoundGrid1.Binder.AddRelation(dataset11.Relations[0].RelationName);
			 m_Root = gridDataBoundGrid1.Binder.RootHierarchyLevel;

			m_Root.LayoutColumns(new string[] {"Portfolio", "-", "-", "-", "-", "-", "-", "-"});
			m_Quotes.LayoutColumns(new string[]{"Symbol", "Compress", "Date", "Open", "High", "Low", "Close", "Volume"});

			GridModel m = gridDataBoundGrid1.Model;

			m.Rows.HeaderCount++;
			m.Rows.FrozenCount++;

			m.Rows.Hidden[0] = true;
			this.gridDataBoundGrid1.Binder.SuspendBinding();
			FillDataSEt();
			this.gridDataBoundGrid1.Binder.ResumeBinding();
			m_Root.RowStyle.BackColor = Color.Yellow;
			gridDataBoundGrid1.ExpandAll();

			gridDataBoundGrid1.ResizeColsBehavior = gridDataBoundGrid1.ResizeColsBehavior | GridResizeCellsBehavior.InsideGrid;
			this.gridDataBoundGrid1.EndUpdate(true);
			this.Cursor = Cursors.Default;

		}


		/// <summary>
		/// Add indicator
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void button2_Click_1(object sender, System.EventArgs e)
		{
			try 
			{
				this.Cursor = Cursors.WaitCursor;
				this.gridDataBoundGrid1.BeginUpdate();
				this.gridDataBoundGrid1.Binder.ResetHierarchyLevels();
				gridDataBoundGrid1.DataSource = null;
				gridDataBoundGrid1.DataMember = "";
				

				for(Int32 i = 0; i < 4; i++) 
				{
					dataset11.Quote.Columns.Add("asd" + i.ToString(), typeof(Double));
				}
				
				gridDataBoundGrid1.DataSource = dataset11;
				gridDataBoundGrid1.DataMember = dataset11.Portfolio.TableName;

				m_Quotes =  gridDataBoundGrid1.Binder.AddRelation(dataset11.Relations[0].RelationName);
				m_Root = gridDataBoundGrid1.Binder.RootHierarchyLevel;

				m_Root.LayoutColumns(new string[] {"Portfolio", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-"});
				m_Quotes.LayoutColumns(new string[]{"Symbol", "Compress", "Date", "Open", "High", "Low", "Close", "Volume", "asd0", "asd1", "asd2", "asd3"});

				m_Root.RowStyle.BackColor = Color.Yellow;
				GridModel m = gridDataBoundGrid1.Model;

				m.Rows.HeaderCount++;
				m.Rows.FrozenCount++;

				m.Rows.Hidden[0] = true;

				m.CoveredRanges.Add(GridRangeInfo.Cells(2,2,2,9));
				m.CoveredRanges.Add(GridRangeInfo.Cells(1,10,1,13));

				gridDataBoundGrid1.ExpandAll();

				this.gridDataBoundGrid1.EndUpdate();
				gridDataBoundGrid1.Refresh();
			} 
			catch(Exception ex) 
			{
				System.Diagnostics.Debug.WriteLine(ex.ToString());
				System.Windows.Forms.MessageBox.Show(".\r\n" + ex.Message, "Error", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
			}
			finally
			{
				this.Cursor = Cursors.Default;
			}
		}


//		System.Windows.Forms.Timer m_timer = new Timer();

//
//		private void m_timer_Tick(object sender, EventArgs e)
//		{
//			for(Int32 i = 0; i < 200; i++) 
//			{
//				Dataset1.QuoteRow r = (Dataset1.QuoteRow ) dataset11.Quote.Rows[i];
//				r.Open += DateTime.Now.Second;
//				r.High+= DateTime.Now.Second;
//				r.Low += DateTime.Now.Second;
//				r.Close+= DateTime.Now.Second;
//			}
//
//			gridDataBoundGrid1.Refresh();
//		}

//		private void gridDataBoundGrid1_DrawCell(object sender, Syncfusion.Windows.Forms.Grid.GridDrawCellEventArgs e)
//		{
////			GridBoundRecordState rs = gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(e.RowIndex);
////			object o = rs.Table;
////
////			if( o == null ) return;
////
////			if( o is DataView )
////			{
////				if ( ((DataView)o).Table == dataset11.Portfolio)
////				{
////					if( rs.Position % 2 == 0 )
////						e.Style.BackColor = System.Drawing.Color.LightGray;
////					else
////						e.Style.BackColor = Color.Yellow;
////
////					e.Style.Font.Bold = true;
////				}
////			}
//		}

		private void gridDataBoundGrid1_PrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventArgs e)
		{
			if(e.RowIndex == 2)
			{
				switch(e.ColIndex)
				{
					case 10:
					case 11:
					case 12:
					case 13:
						e.Style.Text = "Col" + e.ColIndex;
						break;
					default:
						break;
				}
			}
			else if(e.RowIndex == 1)
			{
				switch(e.ColIndex)
				{
					case 10:
						e.Style.Text = "Added Cols";
						e.Style.HorizontalAlignment = GridHorizontalAlignment.Center;
						break;
					default:
						
						break;
				}
			}
			else if(e.RowIndex == 0)
			{
				switch(e.ColIndex)
				{
					case 2:
						e.Style.Text = "";
						break;
					default:
						
						break;
				}
			}
		}

//		private void btnTimer_Click(object sender, System.EventArgs e)
//		{
//			m_timer.Interval = 1000;
//			m_timer.Tick += new EventHandler(m_timer_Tick);
//			m_timer.Start();	
//		}
//
//		private void btnAddDatatoIndicator_Click(object sender, System.EventArgs e)
//		{
//			for(Int32 i = 0; i < dataset11.Quote.Count; i++) 
//			{
//				for(Int32 j = 0; j < dataset11.Quote.Columns.Count; j++) 
//				{
//					if( dataset11.Tables[0].Columns[j].ColumnName=="ID" ) continue;
//					if( dataset11.Tables[0].Columns[j].ColumnName=="PortfoliioID" ) continue;
//					if( dataset11.Tables[0].Columns[j].ColumnName=="Sumbol" ) continue;
//					if( dataset11.Tables[0].Columns[j].ColumnName=="Compress" ) continue;
//					if( dataset11.Tables[0].Columns[j].ColumnName=="Date" ) continue;
//					
//					dataset11.Tables[0].Rows[i][j] = i;
//				}
//			}
//
//			gridDataBoundGrid1.Refresh();
//		}
	}
}
